unit F_mouse;
INTERFACE
type
  MouseItemType=record
    x1,y1,x2,y2:integer;
    Butt:word;
    Key:word;
  end;
type
  MouseHandlerType=procedure(Mask,Buttons,x,y,dx,dy:integer);
const
  leftbutton=1;
  rightbutton=2;
  centerbutton=4;
  anybutton=7;
const
  textratiox:byte=8;
  textratioy:byte=8;
{inimouse}
function IsMouse:boolean;
function InitMouse:boolean;
procedure setmousepage(page:byte);
function GetMousePage:byte;
procedure SetStepToPixel(hor,ver:integer);
procedure GetStepToPixel(hor,ver:integer);
procedure SetDoubleSpeed(Speed:word);
function GetDoubleSpeed:word;
{coordinates}
function MouseTextCooX(x:integer):byte;
function MouseTextCooY(y:integer):byte;
function MouseGraphCooX(x:byte):integer;
function MouseGraphCooY(y:byte):integer;
procedure MouseWhereXY(var x,y:integer);
procedure MouseGotoXY(x,y:integer);
function MouseWhereX:byte;
function MouseWhereY:byte;
function MouseIn(x1,y1,x2,y2:integer):boolean;
{button's status}
function NumButton:byte;
procedure GetMouseState(var butt,x,y:integer);
function MousePressed:boolean;
procedure MouseButtPressed(butt:integer;var stat,count,x,y:integer);
procedure MouseButtReleased(butt:integer;var stat,count,x,y:integer);
{windows}
procedure MouseWindow(x1,y1,x2,y2:integer);
procedure MouseScreen;
{pointer form}
procedure ShowMouse;
procedure HideMouse;
procedure MouseTextCursor(scrmask,curmask:word);
procedure MouseBlink(yup,ydn:byte);
procedure MouseGraphCursor(var scrcurmask;x,y:byte);
{save/backup status}
function MouseBuffSize:word;
procedure SaveMouse(var buff);
procedure RestoreMouse(var buff);
{keyboard emulation}
procedure SetMouseItem(nitem:byte;var items);
procedure AddMouseItem(item:mouseitemtype);
procedure ClearMouseItems;
procedure GetMouseItem(var nitem:byte;var items);
function KeyOrMousePressed:boolean;
function ReadKeyOrMouse:char;
{mouse calc events}
procedure SetMouseHandler(mask:word;proc:mousehandlertype);
procedure ChangeMouseHandler(mask:word;proc:mousehandlertype;
                             var oldmask:word;var oldproc:pointer);
procedure ClearMouseHandler;
IMPLEMENTATION

{mouseini}
uses dos,crt;
type
  MouseItems=array[1..2*MaxInt div sizeof(mouseitemtype)] of MouseItemType;
  PMouseIt=^MouseItems;
const
  MousePresent:boolean=false;
  ItemsList:PMouseIt=nil;
  NMouseItem:byte=0;
  MouseVisible:boolean=false;
  x1m:integer=0;
  y1m:integer=0;
  x2m:integer=639;
  y2m:integer=199;
  Speed2:word=128;
  VerRat:integer=8;
  HorRat:integer=8;
  NButton:byte=0;
var reg:registers;

function IsMouse:boolean;
var
  p:pointer;
  k,x,y:integer;
  is:boolean; {202}
BEGIN
  if NButton=0 then
    begin
      GetIntVec($33,p);
      is:=p<>nil;
      if is then with reg do
        begin
          ax:=$3;
          bx:=$FFFF;
          Intr($33,reg);
          is:=bx<>$FFFF
        end;
      MousePresent:=is
    end;
  IsMouse:=MousePresent
END;
function InitMouse:boolean;
BEGIN
  with reg do
    begin
      ax:=0;
      intr($33,reg);
      MousePresent:=ax=$FFFF;
      NButton:=bx
    end;
  ClearMouseItems;
  SetMousePage(0);
  HideMouse;
  MouseScreen
END;

procedure setmousepage(page:byte);
BEGIN
  with reg do
    begin
      ax:=$1D;
      bl:=page;
      bh:=0;
      intr($33,reg)
    end
END;

function GetMousePage:byte;
BEGIN
  with reg do
    begin
      ax:=$1E;
      intr($33,reg);
      getmousepage:=bl
    end
END;

procedure SetStepToPixel(hor,ver:integer);
BEGIN
  if ismouse then with reg do
    begin
      ax:=$0F;
      cx:=hor and $7FFF;
      dx:=ver and $7FFF;
      horrat:=cx;
      verrat:=dx;
      intr($33,reg)
    end
END;

procedure GetStepToPixel(hor,ver:integer);
BEGIN
  if ismouse then with reg do
    begin
      hor:=horrat;
      ver:=verrat
    end
END;

procedure SetDoubleSpeed(Speed:word);
BEGIN
  if ismouse then with reg do
    begin
      ax:=$13;
      dx:=speed;
      speed2:=speed;
      intr($33,reg);
    end
END;

function GetDoubleSpeed:word;
BEGIN
  getdoublespeed:=speed2
END;

{coords}
function MouseTextCooX(x:integer):byte;
BEGIN
  mousetextcoox:=x div textratiox+1
END;

function MouseTextCooY(y:integer):byte;
BEGIN
  mousetextcooy:=y div textratioy+1
END;

function MouseGraphCooX(x:byte):integer;
BEGIN
  mousegraphcoox:=(x-1)*textratiox
END;

function MouseGraphCooY(y:byte):integer;
BEGIN
  mousegraphcooy:=(y-1)*textratioy
END;

procedure MouseWhereXY(var x,y:integer);
BEGIN
  if ismouse then with reg do
    begin
      ax:=$3;
      intr($33,reg);
      x:=cx;
      y:=dx
    end
  else
    begin
      x:=-1;
      y:=-1
    end
END;

procedure MouseGotoXY(x,y:integer);
BEGIN
  if ismouse then with reg do
    begin
      ax:=$4;
      cx:=x;
      dx:=y;
      intr($33,reg)
    end
END;

function MouseWhereX:byte;
BEGIN
  if ismouse then with reg do
    begin
      ax:=$3;
      intr($33,reg);
      mousewherex:=mousetextcoox(cx)
    end
  else mousewherex:=0
END;

function MouseWhereY:byte;
BEGIN
  if ismouse then with reg do
    begin
      ax:=$3;
      intr($33,reg);
      mousewherey:=mousetextcooy(dx)
    end
  else
    mousewherey:=0
END;

function MouseIn(x1,y1,x2,y2:integer):boolean;
BEGIN
  if ismouse then with reg do
    begin
      ax:=$3;
      intr($33,reg);
      mousein:=(cx>=x1) and (cx<=x2) and (dx>=y1) and (dx<=y2)
    end
  else mousein:=false
END;

{buttons status}
function NumButton:byte;
BEGIN
  numbutton:=nbutton
END;

procedure GetMouseState(var butt,x,y:integer);
BEGIN
  if ismouse then with reg do
    begin
      ax:=$3;
      intr($33,reg);
      butt:=bx;
      x:=cx;
      y:=dx
    end
  else
    begin
      butt:=0;
      x:=0;
      y:=0
    end
END;

function MousePressed:boolean;
BEGIN
  if ismouse then with reg do
    begin
      ax:=$3;
      intr($33,reg);
      mousepressed:=bx<>0
    end
  else mousepressed:=false
END;

procedure MouseButtPressed(butt:integer;var stat,count,x,y:integer);
BEGIN
  if ismouse then with reg do
    begin
      ax:=$5;
      bx:=butt;
      intr($33,reg);
      count:=bx;
      x:=cx;
      y:=dx;
      stat:=bx
    end
  else
END;

procedure MouseButtReleased(butt:integer;var stat,count,x,y:integer);
BEGIN
  if ismouse then with reg do
    begin
      ax:=$6;
      bx:=butt;
      intr($33,reg);
      count:=bx;
      x:=cx;
      y:=dx;
      stat:=bx
    end
  else
END;

{windows}
procedure MouseWindow(x1,y1,x2,y2:integer);
BEGIN
  if ismouse then
    begin
      x1m:=x1;
      y1m:=y1;
      x2m:=x2;
      y2m:=y2;
      with reg do
        begin
          ax:=$7;
          cx:=x1;
          dx:=x2;
          intr($33,reg);
          ax:=$8;
          cx:=y1;
          dx:=y2;
          intr($33,reg)
        end
    end
END;

procedure MouseScreen;
var
  x2,y2:integer;
BEGIN
  if ismouse then with reg do
    begin
      ah:=$F;
      intr($10,reg);
      case al of
      1,4,5,13:begin
                 x2:=319;
                 y2:=199
               end;
      15,16:begin
              x2:=639;
              y2:=349
            end;
      17,18:begin
              x2:=639;
              y2:=479
            end;
      else
        x2:=639;
        y2:=199
      end
    end;
  mousewindow(0,0,x2,y2)
END;

{pointer's form}
procedure ShowMouse;
BEGIN
  if ismouse and not mousevisible then with reg do
    begin
      ax:=$1;
      intr($33,reg);
      mousevisible:=true
    end
END;

procedure HideMouse;
BEGIN
  if ismouse and mousevisible then with reg do
    begin
      ax:=$2;
      intr($33,reg);
      mousevisible:=false
    end
END;

procedure MouseTextCursor(scrmask,curmask:word);
BEGIN
  if ismouse then with reg do
    begin
      ax:=$A;
      bx:=0;
      cx:=scrmask;
      dx:=curmask;
      intr($33,reg)
    end
END;

procedure MouseBlink(yup,ydn:byte);
BEGIN
  if ismouse then with reg do
    begin
      ax:=$A;
      bx:=1;
      cx:=yup;
      dx:=ydn;
      intr($33,reg)
    end
END;

procedure MouseGraphCursor(var scrcurmask;x,y:byte);
BEGIN
  if ismouse then with reg do
    begin
      ax:=$9;
      bx:=x;
      cx:=y;
      es:=seg(scrcurmask);
      dx:=ofs(scrcurmask);
      intr($33,reg)
    end
END;

{save/restore status}
function MouseBuffSize:word;
BEGIN
  if ismouse then with reg do
    begin
      ax:=$15;
      bx:=0;
      intr($33,reg);
      mousebuffsize:=bx
    end
  else mousebuffsize:=0
END;

procedure SaveMouse(var buff);
BEGIN
  if ismouse then with reg do
    begin
      ax:=$16;
      es:=seg(buff);
      dx:=ofs(buff);
      intr($33,reg)
    end
END;
procedure RestoreMouse(var buff);
BEGIN
  if ismouse then with reg do
    begin
      ax:=$17;
      es:=seg(buff);
      dx:=ofs(buff);
      intr($33,reg)
    end
END;
{keyboard emulation}

const
  doublechars:boolean=false;
var
  secchar:char;

procedure SetMouseItem(nitem:byte;var items);
BEGIN
  if ismouse then
    begin
      clearmouseitems;
{203} getmem(itemslist,nitem*sizeof(mouseitemtype));
      move(items,itemslist^,nitem*sizeof(mouseitemtype));
      nmouseitem:=nitem
    end
END;

procedure AddMouseItem(item:mouseitemtype);
var
  p:pmouseit;
  k:byte;
BEGIN
  if ismouse then
    begin
      k:=nmouseitem;
      getmem(p,(k+1)*sizeof(mouseitemtype));
      move(itemslist^,p^,k*sizeof(mouseitemtype));
      move(item,p^[k+1],sizeof(mouseitemtype));
      clearmouseitems;
      nmouseitem:=k+1;
      itemslist:=p
    end
END;

procedure ClearMouseItems;
BEGIN
  if ismouse and (nmouseitem<>0) then
    begin
      freemem(itemslist,nmouseitem*sizeof(mouseitemtype));
      nmouseitem:=0
    end
END;

procedure GetMouseItem(var nitem:byte;var items);
BEGIN
  if ismouse and (nmouseitem<>0) then
    begin
      nitem:=nmouseitem;
      move(itemslist^,items,nmouseitem*sizeof(mouseitemtype))
    end
END;

function KeyOrMousePressed:boolean;
var
  b,k:integer;
  mouseactive:boolean;
BEGIN
  if keypressed then keyormousepressed:=true
  else with reg do
    begin
      ax:=$3;
      intr($33,reg);
      if (bx<>0) and (nmouseitem<>0) then   {line539}
        begin
          mouseactive:=false;
          for k:=1 to nmouseitem do
          if not mouseactive then
            with itemslist^[k] do
            begin
              case butt of
                leftbutton:b:=bx and leftbutton;
                rightbutton:b:=bx and rightbutton;
                centerbutton:b:=bx and centerbutton;
                anybutton:b:=bx
              else b:=0;
              end;
              mouseactive:=(b<>0) and
                mousein(mousegraphcoox(x1),mousegraphcooy(y1),
                        mousegraphcoox(x2),mousegraphcooy(y2))
          end;
        keyormousepressed:=mouseactive
      end
      else keyormousepressed:=false
    end
END;
function ReadKeyOrMouse:char;
var
  k:byte;
  b,bb:word;
  mouseactive:boolean;
label
  loop;
BEGIN
loop:
  if not ismouse or keypressed then
    readkeyormouse:=readkey
  else if doublechars then
    begin
      doublechars:=false;
      readkeyormouse:=secchar
    end
  else if nmouseitem<>0 then with reg do
    begin
      mouseactive:=false;
      ax:=$3;
      intr($33,reg);
      bb:=bx;
      if bb<>0 then
      for k:=1 to nmouseitem do
        if not mouseactive then
          with itemslist^[k] do begin
            case butt of
              leftbutton  : b:=bb and leftbutton;
              rightbutton : b:=bb and rightbutton;
              centerbutton: b:=bb and centerbutton;
              anybutton   : b:=bb;
            else b:=0;
            end;
            if (b<>0) and mousein(mousegraphcoox(x1),mousegraphcooy(y1),
                                  mousegraphcoox(x2),mousegraphcooy(y2)) then
              begin
                mouseactive:=true;
                readkeyormouse:=char(lo(key));
                if lo(key)=0 then
                  begin
                    doublechars:=true;
                    secchar:=chr(hi(key))
                  end
              end
          end;
      if not mouseactive then goto loop
    end
  else readkeyormouse:=readkey
END;

{mouse calc events}
const
  olduserproc:pointer=nil;
var
  userproc:mousehandlertype absolute olduserproc;
  oldax:word;
procedure MouseHandler; Far; Assembler;
asm
  push bp
  push ds
  push es
  push ax
  mov  ax,SEG @DATA
  mov  ds,ax
  pop  ax
  mov  oldax,ax
  mov  ax,Word ptr [olduserproc]
  or   ax,Word ptr [olduserproc+2]
  jz   @
  mov  ax,oldax
  push ax
  push bx
  push cx
  push dx
  push di
  push si
  call [userproc]
@:pop es
  pop ds
  pop bp
  ret far
end;
procedure SetMouseHandler(mask:word;proc:mousehandlertype);
BEGIN
  if ismouse then with reg do
    begin
      userproc:=proc;
      ax:=$0C;
      cx:=Mask;
      es:=seg(mousehandler);
      dx:=ofs(mousehandler);
      intr($33,reg)
    end
END;

procedure ChangeMouseHandler(mask:word;proc:mousehandlertype;
                             var oldmask:word;var oldproc:pointer);
BEGIN
  if ismouse then with reg do
    begin
      oldproc:=olduserproc;
      ax:=$14;
      cx:=mask;
      es:=seg(mousehandler);
      dx:=ofs(mousehandler);
      intr($33,reg);
      oldmask:=cx
    end
END;

procedure ClearMouseHandler;
BEGIN
  if ismouse then with reg do
    begin
      ax:=$0C;
      cx:=0;
      es:=0;
      dx:=0;
      intr($33,reg)
    end
END;
END.